/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.base.ui.layout.auto;

import org.fortiss.tooling.base.model.element.IConnection;
import org.fortiss.tooling.base.model.element.IConnector;
import org.fortiss.tooling.base.model.element.IHierarchicElement;

/**
 * Interface used by {@link IAutoLayouter} to estimate dimensions requirements of elements (for the
 * respective editor for which the automatic layout is performed).
 * 
 * @author barner
 */
public interface IAutoLayouterTapeMeasure {
	/** Estimates the width requirements of the given element. */
	public int getElementWidth(IHierarchicElement element);

	/** Estimates the height requirements of the given element. */
	public int getElementHeight(IHierarchicElement element);

	/** Estimates the width requirements of the given connector. */
	public int getConnectorWidth(IConnector connector);

	/** Estimates the height requirements of the given connector. */
	public int getConnectorHeight(IConnector connector);

	/** Estimates the width requirements of the given connection. */
	public int getConnectionWidth(IConnection connection);
}
