/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.utils;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.fortiss.tooling.kernel.extension.data.IElementCompositionContext;

/**
 * Utility class for composition.
 * 
 * @author aravantinos
 */
public class CompositionUtils {

	/** Composition context for pasting. */
	public static class PasteContext implements IElementCompositionContext {

		/** Object being edited at the moment of pasting. */
		public EObject editedObj;

		/** Copier used for pasting. */
		public EcoreUtil.Copier copier;

		/** Constructor. */
		public PasteContext(EObject activeEditor, EcoreUtil.Copier copier) {
			this.editedObj = activeEditor;
			this.copier = copier;
		}
	}
}
